/* C++ */

#ifndef SC_CLOCK_H
#define SC_CLOCK_H

#include<sc_signal.h>

namespace sc_core
{
    class sc_clock: public sc_signal<bool>
    {
        public:
        sc_clock()
        {
            next_value =true;
        };

        explicit sc_clock(const char* name):sc_signal(name)
        {
            next_value =true;
        };

        private:

        void invert()
        {
            previous_value = current_value;
            current_value = !current_value;
            next_value =  current_value;
        }

        // Disabled
        sc_clock(const sc_clock&);
    };
}


#endif
