/* C++ */
#ifndef SYSTEMC_H
#define SYSTEMC_H

#include <sc_module.h>
#include <sc_signal.h>
#include <sc_signal_ports.h>
#include <sc_fifo.h>
#include <sc_fifo_ports.h>
#include <sc_sensitive.h>
#include <sc_clock.h>
#include <sc_trace.h>
#include <sc_event.h>

#define sc_biguint sc_uint
#define sc_bigint  sc_int

void sc_start(int time);

inline void sc_start()
{
    sc_start(-1);
}


using namespace sc_core;

template<int W>
sc_lv<W> to_sc_lv(const char*);

template<int W>
sc_lv<W> to_sc_bv(const char*);

#endif
